#!/bin/sh

export export PATH=/usr/bin:/bin
umask 077

# inline stdout redirection for sh
# https://stackoverflow.com/questions/3173131/redirect-copy-of-stdout-to-log-file-from-within-bash-script-itself
check_tee_output()
{
    # copy (append) stdout and stderr to log file if TEE is unset or true
    if [ -z "${TEE}" ] || [ "${TEE}" = true ]; then
	TEE=false "$0" 2>&1 | tee {{ dnscrypt_reporting_dest }}/dnscrypt-report-"$(date +%Y%m%d)" >/dev/null
        exit $?
    fi
}

check_tee_output

date=$(date +%Y%m%d)
echo
echo
echo "      DNSCRYPT-PROXY2 DAILY REPORT ${date}"
echo
echo

f=/var/log/dnscrypt-proxy2-query.log
if [ -f "${f}" ]; then
  echo ${f}

  echo "*** per source IP"
  cut -f 2 "${f}" | sort | uniq -c | sort -nr
  echo
  echo "*** per dns query type"
  cut -f 4 "${f}" | sort | uniq -c | sort -nr
  echo
  echo "*** per result"
  cut -f 5 "${f}" | sort | uniq -c | sort -nr
  echo
  echo "*** per domain, top/flop"
  cut -f 3 "${f}" | sort | uniq -c | sort -nr | head -10
  cut -f 3 "${f}" | sort | uniq -c | sort -nr | tail -10
  echo
  echo

  echo "*** REJECT top"
  grep REJECT "${f}" | cut -f 3 | sort | uniq -c | sort -nr| head -10
  echo
  echo "*** SERVFAIL"
  grep SERVFAIL "${f}" | cut -f 2,3,4,5,7
  echo
  echo "*** TXT top"
  grep TXT "${f}" | cut -f 2,3,4,5,7 | head -20
  echo
  echo "*** SRV top"
  grep SRV "${f}" | cut -f 2,3,4,5,7 | head -20
  echo
  echo
fi

f2=/var/log/dnscrypt-proxy2-blacklist.log
if [ -f "${f2}" ]; then
  echo ${f2}

  echo "*** per source IP"
  cut -f 2 "${f2}" | sort | uniq -c | sort -nr
  echo
  echo "*** per domain, top/flop"
  cut -f 3 "${f2}" | sort | uniq -c | sort -nr | head -10
  cut -f 3 "${f2}" | sort | uniq -c | sort -nr | tail -10
  echo
  echo
fi

f3=/var/log/dnscrypt-proxy2-nx.log
if [ -f "${f3}" ]; then
  echo ${f3}

  echo "*** per source IP"
  cut -f 2 "${f3}" | sort | uniq -c | sort -nr
  echo
  echo "*** per dns query type"
  cut -f 4 "${f3}" | sort | uniq -c | sort -nr
  echo
  echo "*** per domain, top/flop"
  cut -f 3 "${f3}" | sort | uniq -c | sort -nr | head -10
  cut -f 3 "${f3}" | sort | uniq -c | sort -nr | tail -10
  echo
  echo
fi

find /var/tmp -name 'dnscrypt-report-*' -mtime +10 -exec rm {} \; 2>/dev/null
